var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import defaultOptions from '../../defaultOptions';
import { EditingMode, FilteringMode, SortingMode } from '../../enums';
import { wrapDispatch } from '../../Utils/ActionUtils';
import { getExpandedGroups } from '../../Utils/GroupUtils';
import { extendProps, prepareTableOptions } from '../../Utils/PropsUtils';
import FilterRow from '../FilterRow/FilterRow';
import HeadRow from '../HeadRow/HeadRow';
import TableBody from '../TableBody/TableBody';
export var Table = function (props) {
    var _a = props.childAttributes, childAttributes = _a === void 0 ? {} : _a, _b = props.editableCells, editableCells = _b === void 0 ? [] : _b, _c = props.editingMode, editingMode = _c === void 0 ? EditingMode.None : _c, filteringMode = props.filteringMode, _d = props.sortingMode, sortingMode = _d === void 0 ? SortingMode.None : _d, _e = props.selectedRows, selectedRows = _e === void 0 ? [] : _e, groups = props.groups, _f = props.data, data = _f === void 0 ? [] : _f;
    var groupsExpanded = props.groupsExpanded;
    var preparedOptions = prepareTableOptions(props);
    if (groups && !groupsExpanded) {
        groupsExpanded = getExpandedGroups(preparedOptions.groupedData);
    }
    var theadRef = React.useRef(null);
    var dispatch = wrapDispatch(__assign({}, props), theadRef);
    var componentProps = {
        className: defaultOptions.css.table,
    };
    var tableProps = extendProps(componentProps, props, childAttributes.table, dispatch);
    var areAllRowsSelected = data.length === selectedRows.length;
    return (React.createElement("div", { className: 'ka' },
        React.createElement("table", __assign({}, tableProps),
            React.createElement("thead", { className: defaultOptions.css.thead, ref: theadRef },
                React.createElement(HeadRow, { areAllRowsSelected: areAllRowsSelected, groupColumnsCount: preparedOptions.groupColumnsCount, columns: preparedOptions.columns, dispatch: dispatch, sortingMode: sortingMode }),
                filteringMode === FilteringMode.FilterRow &&
                    (React.createElement(FilterRow, { columns: preparedOptions.columns, dispatch: dispatch, groupColumnsCount: preparedOptions.groupColumnsCount }))),
            React.createElement(TableBody, __assign({}, props, { childAttributes: childAttributes, columns: preparedOptions.columns, data: preparedOptions.groupedData, dispatch: dispatch, editableCells: editableCells, editingMode: editingMode, groupColumnsCount: preparedOptions.groupColumnsCount, groupedColumns: preparedOptions.groupedColumns, groupsExpanded: groupsExpanded, selectedRows: selectedRows })))));
};